/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */
package org.azuki.bean.apportal.editor ;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;

import org.azuki.bean.apportal.shared.ConstAppPortal;
import org.azuki.common.editor.basic.AbstractEditor;
import org.azuki.common.editor.jdom.JDOMAttributeField;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class AppPortalEditor extends AbstractEditor
{
	private JDOMAttributeField nameField ;
	private JDOMAttributeField titlField ;
	
	private JFormPanel form ;
	
	/*
	 * AbstractEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		Element applLmen = JDOMUtil.getElement(para, ConstAppPortal.APPL) ;
		Attribute applNameAttr = JDOMUtil.getAttribute(applLmen, ConstAppPortal.APPL_NAME) ; 
		Attribute applTitlAttr = JDOMUtil.getAttribute(applLmen, ConstAppPortal.APPL_TITLE) ;
		
		nameField = new JDOMAttributeField(applNameAttr) ;
		titlField = new JDOMAttributeField(applTitlAttr) ;
		
		form = new JFormPanel() ;
		form.addField(nameField, "Name") ;
		form.addField(titlField, "Title") ;
		
		setDialogTitle("Application portal") ;
		
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(form, BorderLayout.NORTH) ;
	}
}