/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */
package org.azuki.bean.apportal.editor ;

import java.awt.BorderLayout;
import java.util.List;

import javax.swing.BorderFactory;

import org.azuki.bean.apportal.shared.ConstAppPortal;
import org.azuki.common.editor.jdom.JDOMAttributeField;
import org.azuki.common.editor.pointcut.AbstractPointcutEditor;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class AppPortalPointcutEditor extends AbstractPointcutEditor
{
	private JDOMAttributeField nameField ;
	
	private JFormPanel form ;
	
	/*
	 * AbstractEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		Element entyLmen = JDOMUtil.getElement(para, ConstAppPortal.ENTY) ;
		Attribute entyNameAttr = JDOMUtil.getAttribute(entyLmen, ConstAppPortal.ENTY_NAME) ; 
		
		nameField = new JDOMAttributeField(entyNameAttr) ;
		
		form = new JFormPanel() ;
		form.addField(nameField, "Entry name") ;
		
		setDialogTitle("Application entry") ;
		
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(form, BorderLayout.NORTH) ;
	}

	@Override
	final public void initFields(List<Element> flds)
	{}

	@Override
	final public void initMethods(List<Element> mths)
	{}
}