package org.azuki.bean.authenticator.shared ;

/**
 * Parameter structure:
 * 	<para>
 * 		<ldap serverurl="ldap://localhost:389" basedn="o=societedemo,c=fr" user="uid=?"/>
 * 		<context type="java.naming.factory.initial" value="com.sun.jndi.ldap.LdapCtxFactory"/>
 * 		<context type="java.naming.security.authentication" value="simple"/>
 *         ...
 *     </para>    
 * 			
 * 		
 */
public interface ConstLDAP
{
	final static public String LDAP = "ldap" ; // Tag
	final static public String SERVER_URL = "serverurl";
	final static public String BASE_DN		    = "basedn";
	final static public String LDAP_LOGIN  = "user";
	final static public String CONTEXT		= "context"; //Tag
	final static public String TYPE				= "type" ;
	final static public String VALUE			= "value" ;
}