/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.basicrpc.server.imp ;

import java.io.*;

import javax.servlet.http.*;

import org.azuki.client.basicrpc.codec.ObjectEncoder;
import org.azuki.framework.context.Log;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class Response
{
	final static public void write(HttpServletRequest req, HttpServletResponse res, Object obj)
	throws IOException
	{
		boolean thrw = obj instanceof Throwable ;
		
		res.setCharacterEncoding("UTF-8") ;
		if(thrw) res.setStatus(HttpServletResponse.SC_INTERNAL_SERVER_ERROR) ;
		
		PrintWriter pw = res.getWriter() ;
		
		String oenc = thrw ? Log.getStack((Throwable)obj) : ObjectEncoder.encode(obj) ;
		if(oenc!=null) pw.print(oenc) ;
		
		pw.flush() ;
	}
}