/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.command.server.imp.core;

import org.azuki.bean.command.server.imp.queue.OQ;
import org.azuki.framework.command.ICommand;


// Thread Pool Manager


final public class TPM implements ICommand
{
	final static private OQ<Boolean> odr = new OQ<Boolean>() ; // Orders
	
	final static public void create() { odr.put(Boolean.TRUE) ; }
	final static public void exit()   { odr.put(Boolean.FALSE); }
	
	final public Object process()
	{
		// The thread factory must keep is own thread
	    // To be sure there is  enough thread 
	    // . To create a new thread !! 
	    // . To stop Azuki
	    
	    while(true) // Ad vitam aeternam
	    {
	        Boolean B = odr.remove() ; // Creation order 
	    
	        if(Boolean.TRUE==B)
	        {
	            TPool.preCreate() ;
 	        }
	        else
	        {
	            // TODO 
	            // Stop Azuki gracefully ;
	            System.exit(0) ;
	        }
	    }
	}
}