/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.command.server.imp.core;

import org.azuki.bean.command.server.imp.queue.QRd;
import org.azuki.framework.context.ThreadContext;


// Azuki's Thread

final public class Thd implements Runnable
{
	private boolean stop = false ; // Set if thread must stop
	
	private QRd qrd = null;

	final public synchronized void awake(QRd qrd)
	{
		this.qrd = qrd ;
		notify() ;
	}

	final public synchronized void end()
	{
	    stop = true ;
	    notify() ;
	}
	
	final public void run()
	{
		while(true) // ad vitam aeternam
		{
			synchronized(this)
			{
				if(qrd == null)
				{
					ThreadContext.setStatus(false, null) ;

					try { wait() ;  }
					catch (InterruptedException e) {}
				}
			}

			if(stop) return ; // THIS IS THE END !!!
			
			String jname = qrd.getName() ;
			
			ThreadContext.setStatus(true, jname) ; // Running
			
			try
			{
				qrd.process(); // reset performed in the Q reading loop
			}
			// Au cas ou, malgre que process ne doit
			// pas envoye d'exception normalement.
			catch(Throwable t)
			{
				t.printStackTrace();
			}

			qrd = null ; // For Garbage & wait
			
			TPool.back(this);
		}
	}
}
