/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.command.server.imp.queue ;

import java.util.*;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */
final public class OQPF 
{
    final private HashMap<String, OQP> queues = new HashMap<String, OQP>();

    @SuppressWarnings("unchecked")
	final public Map<String, OQP> get(boolean clone)
    {
        if(!clone) return queues ;
        return (Map<String, OQP>)queues.clone();
    }
    
    final synchronized public OQP get(String name)
    {
        OQP queue = queues.get(name);

        if(queue == null)
        {
            queue = new OQP() ;
            queues.put(name, queue);
        }

        return queue ;
    }

	final synchronized public void removeAll()
    {
        Iterator iter = queues.entrySet().iterator() ;
        while(iter.hasNext())
        {
            ((OQP)iter.next()).clear();
        }

        queues.clear();
    }
}