/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.command.server.imp.queue ;

import org.azuki.bean.command.server.imp.core.CPU;

/**
 *   Secure CmdQ
 * 
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class SCmdQ extends CmdQ
{
	final private static SecurityException se = new SecurityException("Queue is protected against this modification") ;

	public SCmdQ(CPU cpu)
	{
		super(cpu, "MAIN") ;
		localSetMaxThread(99999); // defaut
	}
	
	// This method does not appears in IQueue, but 
	// can be use from the CommandBean editor
	final public void localSetMaxThread(int maxthread)
	{
		super.setMaxThread(maxthread) ;
	}
	
	// IQueue methods that must be protect
	//////////////////////////////////////
	@Override
	final public void setMaxThread(int maxread)
	{
		throw se ;
	}
	
	@Override
	final public void setLimit(int max)
	{
		throw se ;		
	}
	
	@Override
	final public void setShift(boolean shift)
	{
		throw se ;
	}
}
