/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.context.editor ;

import java.awt.BorderLayout;
import java.util.*;

import javax.swing.*;

import org.azuki.bean.context.shared.ConstContext;
import org.azuki.common.editor.*;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.editor.pointcut.AbstractPointcutEditor;
import org.azuki.common.util.ListUtil;
import org.jdom.Element;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

@SuppressWarnings("serial")
final public class ContextParameterEditor extends AbstractPointcutEditor
{
	final static private JDOMElementTableBinding tableBinding
	= JDOMElementTableBinding.create(TagCommon.ROW,
									 ListUtil.asList(AttrCommon.NAME, AttrCommon.VALU, AttrCommon.DESC, ConstContext.SCOP),
									 ListUtil.asList(ConstCommon.NAME, ConstCommon.VALU, ConstCommon.DESC, "Object scope"),
									 Collections.singletonMap(ConstContext.SCOP, ConstContext.SCOP_PROCESS)) ;
	
	private JComboBox scopCombo = new JComboBox(new Object[]{ConstContext.SCOP_CONTEXT, ConstContext.SCOP_PROCESS}) ; 
	
	private JDOMElementTablePanel tablePanel ;
	
	/*
	 * AbstractEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		scopCombo = new JComboBox(ConstContext.SCOPS) ;
		
		tablePanel = new JDOMElementTablePanel(para, tableBinding) ;
		tablePanel.getTable().getColumnModel().getColumn(3).setCellEditor(new DefaultCellEditor(scopCombo)) ;
		
		setDialogTitle("Configure context parameter") ;
		
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(tablePanel, BorderLayout.CENTER) ;
	}
	
	@Override
	final public void initFields(List<Element> flds)
	{}

	@Override
	final public void initMethods(List<Element> mths)
	{}
}

