/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */


package org.azuki.bean.context.server ;

import java.util.Map;

import org.azuki.bean.context.server.imp.*;
import org.azuki.framework.context.IContext.IStub;
import org.azuki.framework.injection.*;

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class ContextObjectAdvice implements IController
{	
	final private Map<String, IStub> stubs; 
	
	public ContextObjectAdvice(Map<String, IStub> stubs)
	{
		this.stubs = stubs ;
	}
	
	final public Object intercept(InvocationTarget it)
	throws Exception
	{
		Cx cx = TCxMngr.get() ;
		
		// Common method, should be used by other code advice
		Map<String, IStub> saved = PCx.bind(cx, stubs) ;

		try
		{
			return it.proceed() ;
		}
		finally
		{
			PCx.unbind(cx, stubs, saved) ;
		}
	}
	
}