/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.context.server.imp ;

import java.util.*;

import org.azuki.framework.context.IContext.IStub;
import org.azuki.framework.object.ILifecycle;

/**
 * @author Robert Bakic (robert.bakic@gmail.com)
 */

public class C
{
	// Object bounded
    final private Map<String, IStub> stubs = new Hashtable<String, IStub>();    

    // ! null value can be bound
	// TODO : manage labl   
    final public boolean isBound(String key)
    {
    	return stubs.get(key)==null?false:true;
    }

	// TODO : manage labl
    final public Object getObject(String key)
    {
    	IStub stub = stubs.get(key) ;
    	if(stub!=null) return stub.getObject();
    	return null ; // not found
    }
	
    // This method create the object using the factory,
    final public Object lookup(String key, Object... args)
    throws Exception
    {
		// TODO : manage labl
    	return PC.lookup(stubs, key, args) ;
    }    

    final public IStub getStub(String key)
    {
    	return stubs.get(key) ;
    }
    
    final public Map<String, IStub> getStubs()
    {
    	return stubs ;
    }
        
    // for IContext
    final public IStub bind(String key, Object obj, ILifecycle life)
    {
		return bind(key, new Stub(obj, life)) ;
    }       
    
    final public IStub bind(String key, IStub stub)
    {
		// Saves previous context's object with same name
		return stubs.put(key, stub) ; //stubs.get(key) ;
//		bind(key, stub) ;
//		return saved ;
    }       
    
    final public void unbind(String key)
    {
    	unbind(key, null) ;
    }
    
    
    // Unbind a object from the context (restore previous binding)
    final public void unbind(String key, IStub saved)
    {
		IStub stub = stubs.remove(key) ;
		if(stub!=null) PC.finalize(stub) ;
		// Rebind old-object
		if(saved!=null)	bind(key, saved) ;		
    }       

	final public void end()
    {
		PC.end(stubs) ;
    }	
}