/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.context.server.imp ;

import org.azuki.common.util.Counter;
import org.azuki.framework.context.IContext;

/**
 * @author Robert Bakic (robert.bakic@gmail.com)
 */

public class Cx extends C implements IContext
{
	final static private Counter cntpid = new Counter(0); // Process ID
	final static private Counter count = new Counter(0); // Context'ID
	
	final private int pid ;
	final private int id ;

	public Cx()
	{
		this(cntpid.next()) ;
	}

	private Cx(int pid)
	{
		this.pid = pid ;
		id = count.next() ; // Synchronized to avoid duplicate value
	}
		
	final public int getProcessID() { return pid; }
	final public int getID()  { return id; }
	
	final public Cx fork() 
	{
		Cx newcx = new Cx(pid) ; // Fork with same PID
		
		PC.copy(this, newcx) ;
		
		return newcx ;
	}	
}