/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.context.server.imp ;

import java.util.*;

import org.azuki.framework.context.IContext.IStub;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

public class PCx
{	
	final static public Map<String, IStub> bind(C c, Map<String, IStub> stubs)
	{	
		Map<String, IStub> saved = null ; // Lazy
		
		for(Map.Entry<String, IStub> ety : stubs.entrySet())
		{
			String  name = ety.getKey();
			IStub stub = ety.getValue() ;

			// Saves previous context's object with same name
			IStub oldstub = c.bind(name, stub) ;
			if(oldstub!=null)
			{
				if(saved==null) saved = new HashMap<String, IStub>() ;
				saved.put(name, oldstub) ;
			}
		}
		
		return saved ;
	}

	final static public void unbind(C c, Map<String, IStub> stubs, Map<String, IStub> saved)
	{	
		// Unbind new only
		for(String name : stubs.keySet())
			c.unbind(name, saved!=null?saved.get(name):null) ;
	}
}