/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.event.editor.imp ;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;

import org.azuki.bean.event.shared.*;
import org.azuki.common.editor.IEditorContext;
import org.azuki.common.editor.jdom.JDOMComboField;
import org.azuki.common.editor.page.Page;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.azuki.framework.command.ICommand.Priority;
import org.jdom.*;

@SuppressWarnings("serial")
public class EventHandlerMethodPage extends Page
{
	protected JDOMComboField prioField ;
	protected JFormPanel form ;
		
	protected TopicSelectionPane topcSelectionPane ;
	
	/*
	 * Page
	 */
	@Override
	final public void init(IEditorContext ectx, Element lmen)
	{
		// priority
		Element prioLmen = JDOMUtil.getElement(lmen, TagEvent.PRIO) ;
		Attribute priority = JDOMUtil.getAttribute(prioLmen, AttrEvent.NAME) ;
		
		prioField = new JDOMComboField((Object[])Priority.values()) ;
		prioField.setAttribute(priority) ;
		
		form = new JFormPanel() ;
		form.addField(prioField, "Priority") ;
		
		// topics selection
		topcSelectionPane = new TopicSelectionPane(ectx, lmen) ;
				
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(form, BorderLayout.NORTH) ;
		add(topcSelectionPane, BorderLayout.CENTER) ;
	}
}