/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.event.server;

import java.util.*;

import org.azuki.bean.event.shared.*;
import org.jdom.Element;

/*
<pointcut pcid="pcEventPublisher" name="EventPublisherBean" labl="kernel" enab="yes">    
  <para>
    <output name="s1">
       <topic name="TOPIC1" />
       <topic name="TOPIC2" />
    </output>
    <output name="s2">
      ...
    </output>
  </para> 
</pointcut>
*/


final public class EventPublisherAdvice
{
	final private HashMap<String, List<String>> topics = new HashMap<String, List<String>>() ;

	@SuppressWarnings("unchecked")
	public HashMap<String, List<String>> getTopics()
	{ 
		return (HashMap<String, List<String>>)topics.clone(); 
	}	
	
	@SuppressWarnings("unchecked")
	public EventPublisherAdvice(Integer beanID, Element para)
	{
		List<Element> list = para.getChildren(TagEvent.OUTP) ;
		
		for(Element lm : list)
		{
			String output = lm.getAttributeValue(AttrEvent.NAME) ;
	
			List<Element> list2 = lm.getChildren(TagEvent.TOPC) ;
			List<String> tmp = new ArrayList<String>() ;
			for(Element lm2 : list2)
			{
				String topic = lm2.getAttributeValue(AttrEvent.NAME) ;
				tmp.add(topic) ;
			}
			
			// The dummy topic, for direct link
			tmp.add(new StringBuilder("link#").append(beanID).append("#").append(output).toString()) ;
			
			topics.put(output, tmp) ;
		}
	}
		
	final public List<String> getTopics(String output)
	{
		return topics.get(output) ;
	}
}