/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.event.server.imp;

import org.azuki.framework.command.ICommand;
import org.azuki.framework.injection.IMethodProxy;


final public class EventCommand<T> implements ICommand<T>
{
	final private IMethodProxy mp ;
	final private int       args ;
	final private String   topic ;
	final private Object   event ;
	
	public EventCommand(IMethodProxy mp, int args, String topic, Object event)
	{
		this.mp    = mp ;
		this.args  = args ;
		this.topic = topic ;
		this.event = event ;
	}

	@SuppressWarnings("unchecked")
	final public T process()
	throws Exception
	{
    	if(args==2) return (T)mp.call(topic, event) ;
    	if(args==1) return (T)mp.call(event) ;
    	return (T)mp.call() ;
	}
}