/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.event.server.shell;

import java.util.*;

import org.azuki.bean.event.EventPublisherBean;
import org.azuki.bean.event.server.EventPublisherAdvice;
import org.azuki.common.util.Util;
import org.azuki.framework.aop.IPointcut;
import org.azuki.framework.bean.*;

public class EventPublisherShell
{
	final static public String listPointcuts(EventPublisherBean pubr)
	throws Exception
	{
		StringBuilder bdr = new StringBuilder() ;
		
		Collection<IPointcut> pcs = Bean.getPointcuts(pubr.getMetadata().getID()) ;
		for(IPointcut pc : pcs)
		{
			IMetadata tmeta = pc.getTargetMetadata() ;
			
			EventPublisherAdvice adv = (EventPublisherAdvice)pc.getAdvice() ;
			if(adv==null) continue ;
			
			bdr.append("Bean : ") ;
			bdr.append(Util.oneString(tmeta.getName(), tmeta.getLabel())) ;
			bdr.append("\n") ;
			
			for(Map.Entry<String,List<String>> ety : adv.getTopics().entrySet())
			{
				String       topc = ety.getKey() ;
				List<String> lsnr = ety.getValue() ;
				
				bdr.append("\t") ;
				bdr.append("Output Name: ") ;
				bdr.append(topc) ;
				
				for(String s : lsnr)
				{
					bdr.append("\n") ;
					bdr.append("\t") ;
					bdr.append("\t") ;
					bdr.append(s) ;
					bdr.append("\n") ;
				}
			}
		}
		
		return bdr.toString() ;
	}
}