/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.exec.editor;

import java.awt.BorderLayout;

import org.azuki.bean.exec.shared.ConstProcessFactory;
import org.azuki.common.editor.*;
import org.azuki.common.editor.basic.AbstractEditor;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.util.*;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

@SuppressWarnings("serial")
final public class ProcessFactoryEditor extends AbstractEditor
{
	final static private JDOMElementTableBinding tableBinding
	= JDOMElementTableBinding.create(	TagCommon.ROW,
										ListUtil.asList(AttrCommon.NAME, AttrCommon.VALU),
										ListUtil.asList(ConstCommon.NAME, ConstCommon.VALU)) ;
	
	private JDOMAttributeField cmdlField;
	private JDOMElementTablePanel paraTable;
	
	private JFormPanel form ;
	
	/*
	 * AbstractEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		Element execLmen = JDOMUtil.getElement(para, ConstProcessFactory.EXEC) ;
		Attribute cmdlAttr = JDOMUtil.getAttribute(execLmen, ConstProcessFactory.COMMAND) ;
		
		cmdlField = new JDOMAttributeField(cmdlAttr) ;
		
		paraTable = new JDOMElementTablePanel(execLmen, tableBinding) ;
		
		form = new JFormPanel() ;
		form.addField(cmdlField, "Command line") ;
		form.addField(paraTable, "Environment") ;
		
		setDialogTitle("Processing Editor") ;
		
		setLayout(new BorderLayout()) ;
		add(form, BorderLayout.NORTH) ;
	}
}