/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.graniteds.server.imp ;

import org.azuki.bean.graniteds.GraniteDSBean;
import org.azuki.bean.graniteds.shared.ConstGranite;
import org.azuki.common.bean.rpc.Service;
import org.azuki.framework.context.*;

/**
 * @author Robert Bakic (robert.bakic@gmail.com)
 */
public class PojoInvoker
{
	final public Object invoke(String service, Object... arg)
    throws Exception
	{
		GraniteDSBean bean = (GraniteDSBean)ThreadContext.get().getObject(ConstGranite.BIND) ;
    	//Log.info("Granite bean : "+bean) ;
		
    	Log.info("Invocation de : "+service) ;
    	
    	Service serv = bean.getService(service);
		if (serv == null)
			throw new Exception("Service not found: " + service);
    	 
		return serv.call(arg) ;		
	}
}