/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.hibernate.editor;

import java.awt.*;

import javax.swing.*;

import org.azuki.bean.hibernate.shared.ConstHibernate;
import org.azuki.common.editor.basic.AbstractEditor;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.util.ListUtil;
import org.jdom.Element;

@SuppressWarnings("serial")
public class HibernateEditor extends AbstractEditor
{
	final static private JDOMElementTableBinding tableBinding
	= JDOMElementTableBinding.create(	ConstHibernate.MAP,
										ListUtil.asList(ConstHibernate.FILE),
										ListUtil.asList("File")) ;
		
	/*
	 * AbstractEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		JDOMElementTablePanel tprop = new JDOMElementTablePanel(para, JDOMElementTableBinding.getDefault()) ;
		tprop.setPreferredSize(new Dimension(400,200)) ;
		
		JDOMElementTablePanel tmap  = new JDOMElementTablePanel(para, tableBinding) ;
		tmap.setPreferredSize(new Dimension(400,200)) ;
		
		JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT) ;
		split.setBorder(BorderFactory.createEtchedBorder()) ;
		split.setTopComponent(tprop) ;
		split.setBottomComponent(tmap) ;
		
		setDialogTitle("Hibernate editor") ;
		
		setLayout(new BorderLayout()) ;
		add(split, BorderLayout.CENTER) ;
	}
}