/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.injection;

import org.azuki.bean.injection.server.imp.MILogger;
import org.azuki.bean.injection.server.imp.MethodProxyImp.IMILogger;
import org.azuki.common.util.ProcessLifecycle;
import org.azuki.framework.context.IContext;
import org.azuki.framework.object.*;

/**
 *   @author Robert Bakic
 */
final public class ProcessAnalyzerBean implements IObjectFactory<IMILogger>, ILifecycleFactory<IMILogger>
{
	final public String getObjectName()
	{
		return IContext.OBJECT_ANALYZER ;
	}
	
	final public IMILogger createObject(Object... args)
	{
		return new MILogger() ;
	}
	
	final public ILifecycle<IMILogger> getLifeCycle()
	{
		return new ProcessLifecycle<IMILogger>() ;
	}
}
