/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.javarpc.client ;

import java.net.URL;

import org.azuki.client.javarpc.SimpleHttpClient;
import org.azuki.client.javarpc.imp.Misc;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */
final public class TestJavaRpc
{
	final static public void main(String[] args)
	{
		try
		{
			URL codebase = Misc.newURL("localhost", 8081, "/myAppUri") ;
			SimpleHttpClient http = new SimpleHttpClient(codebase) ;
			
			Integer pric = new Integer(100) ;
			
			Object res =  http.invoke("getDiscount", pric) ;
			
			System.out.print(">>>>>>>>"+res) ;

			http.send("getDiscount", pric) ;
		}
		catch(Exception e)
		{
			e.printStackTrace() ;
		}
	}
}











