/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.javarpc.server.imp.nouse ;

import java.io.ByteArrayOutputStream;
import java.net.URL;

import org.azuki.client.javarpc.imp.*;

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */
final public class P2P
{
	// Command pour appel direct entre serveurs Azuki (evite de creer un client HTTP)
	// ! le timeout est fixé arbitrairement a 5 secondes.
	final static public Object invoke(URL url, String service, Object[] args)
	throws Exception
	{
		byte[] content = PZip.serialize(new Object[] {service, args}, new ByteArrayOutputStream()) ;
			
		boolean compressed = false ;

		if(PZip.COMPRESS > 0) // if 0 then no compression
		if(content.length >= PZip.COMPRESS) // si seuil atteint
		{
			content = PZip.compress(content) ;
			compressed = true ;
		}
		
		WaitCallback waitcb = new WaitCallback() ;
		
		Post.post(waitcb, url, null, content, compressed) ;
		
		Object result = waitcb.response() ;
		
		if(result instanceof Exception)
			throw (Exception)result ; // Server side exception
		
		return result ;
	}	
}