/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.jndi.shared;

import java.util.List;

import org.azuki.common.util.ListUtil;
import org.azuki.framework.context.IContext;

public interface ConstJNDI
{
	// Parameters
	final static public String NAMESPACE		= "namespace" ; // Tag
		final static public String NAME				= "name" ;
	
	final static public String REFERENCE		= "reference" ; // Tag
		final static public String CLASSNAME		= "className" ;
		final static public String FACTORY			= "factory";
		final static public String FACTORY_LOCATION	= "factoryLocation" ;
	
	final static public String ADDRESS			= "address" ;
		final static public String TYPE				= "type" ;
		final static public String VALUE			= "value" ;
		
	final static public String CONTEXT 			= "context" ; // Tag
		final static public String BINDING 			= "bind" ;
		
	// Constants
	final static public String JAVA = "java:" ;
	final static public String COMP = "comp" ;
	final static public String ENV  = "env" ;
	final static public String JAVA_COMP_ENV_CONTEXT = JAVA+"/"+COMP+"/"+ENV ;
	
	final static public List<String> CONTEXT_BINDING_KEYS = ListUtil.asList(IContext.OBJECT_DATASOURCE, IContext.OBJECT_LDAP) ;
}
