/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.ooo.shared ;

import java.awt.image.BufferedImage;
import java.io.*;

import javax.imageio.ImageIO;

import org.azuki.framework.context.Log;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */
public class UtilOOO
{
	static private byte[] mpty = null ;
	final static public byte[] emptyImage()
	{
		if(mpty!=null) return mpty ;
		
		ByteArrayOutputStream baos = new ByteArrayOutputStream() ;
		BufferedImage bimg = new BufferedImage(1, 1, BufferedImage.TYPE_INT_ARGB) ;
		
		try
		{ ImageIO.write(bimg, "png", baos) ; }
		catch(Exception ex)
		{ ex.printStackTrace() ; }
		
		try{ baos.close() ; } catch(Exception ex){}
		
		mpty = baos.toByteArray() ;
		return mpty ;
	} 
	
	final static public byte[] getResource(String name)
	throws IOException
	{
		InputStream is = getResourceAsStream(name) ;
		if(is==null) return null ;
		
		byte[] byts = read(is) ;
		
		is.close() ;
		
		return byts ;
	}
	
	final static public InputStream getResourceAsStream(String name)
	throws IOException
	{
		File file = new File(name) ;
		if(file.exists())
		{
			Log.info("Load resource("+name+") from disk...") ;
			return new FileInputStream(file) ;
		}
		
		Log.info("Load resource("+name+") from classloader...") ;
		return Thread.currentThread().getContextClassLoader().getResourceAsStream(name) ;
	}
	
	final static public byte[] read(InputStream is)
	throws IOException
	{
		ByteArrayOutputStream baos = new ByteArrayOutputStream() ;
		
		byte[] 	bufr = new byte[4096] ;
		int 	read = 0 ;
		
		while(true)
		{
			read = is.read(bufr) ;
			if(read==-1) break ;
			
			baos.write(bufr, 0, read) ;
		}
		
		baos.close() ;
		
		return baos.toByteArray() ;
	}
}