/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.queuing.server;

import org.azuki.framework.bean.IMetadata;
import org.azuki.framework.command.*;


public class QueuingAdvice
{
	final static private String prefix = "BeanQueue#" ;
	private IQueue queue;
	
	public QueuingAdvice(IMetadata meta, int thd, int qsize, boolean shift)
	{
		queue = Command.getQueue(new StringBuilder(prefix).append(meta.getID()).toString()) ;
		queue.setLimit(qsize) ;
		queue.setMaxThread(thd) ;
		queue.setShift(shift) ;
		meta.setQueue(queue) ;
	}
	
	public int getMaxThread()
	{
		return queue.getMaxThread(); 
	}
	
	public void setMaxThread(int max)
	{
		queue.setMaxThread(max);
	}
	
	public int getQueueSize()
	{
		return queue.getLimit();
	}
	
	public void setQueueSize(int size)
	{
		queue.setLimit(size);
	}
}
