/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.queuing.server.console;

import java.util.*;

import javax.servlet.http.*;

import org.azuki.bean.queuing.QueuingBean;
import org.azuki.bean.queuing.server.QueuingAdvice;
import org.azuki.common.console.HtmlFactory;
import org.azuki.common.console.html.Table;
import org.azuki.common.console.http.HttpResponse;
import org.azuki.common.util.*;
import org.azuki.framework.aop.IPointcut;
import org.azuki.framework.bean.*;

public class QueuingConsole
{
	final static public String[] tableHeaders = { "Bean", "Queue Size", "Max. Threads" } ; 

	final public static void service(QueuingBean aspt, HttpServlet srv, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{		
		List<List> data = new ArrayList<List>() ;
		
		// table datas
		for(IPointcut pc : Bean.getPointcuts(aspt.getMetadata().getID()))
		{
			QueuingAdvice qa = (QueuingAdvice)pc.getAdvice() ;
			if(qa==null) continue ;
			
			IMetadata tmeta = pc.getTargetMetadata() ;
			
			List row = ListUtil.toList(Util.oneString(tmeta.getName(), tmeta.getLabel()), new Integer(qa.getQueueSize()), new Integer(qa.getMaxThread())) ;
			data.add(row) ;
		}
		
		Table table = HtmlFactory.sortedTable(req, data, tableHeaders) ;
		
		HttpResponse.print(res, table) ;
	}
}
