/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.request.editor;

import java.awt.BorderLayout;
import java.util.List;

import org.azuki.bean.request.shared.ConstRequestHandler;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.editor.pointcut.AbstractPointcutEditor;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

@SuppressWarnings("serial")
public class RequestHandlerEditor extends AbstractPointcutEditor
{
	final private static String[][] bindings = {{ConstRequestHandler.EXACT, 	"Exact"},
												{ConstRequestHandler.STARTWITH, "Starts with"},
												{ConstRequestHandler.ENDWITH, 	"Ends with"},
												{ConstRequestHandler.MATCH, 	"Match"}} ;
	
	JDOMAttributeField name ;
	JDOMRadioGroup bind ;
	
	JFormPanel form ;
	
	/*
	 * AbstractPointcutEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		Element uriLmen = para.getChild(ConstRequestHandler.URI) ;
		if(uriLmen==null)
		{	uriLmen = new Element(ConstRequestHandler.URI) ;
			para.addContent(uriLmen) ; }
		
		Attribute nameAttr = uriLmen.getAttribute(ConstRequestHandler.NAME) ;
		if(nameAttr==null)
		{	nameAttr = new Attribute(ConstRequestHandler.NAME, "(undefined)") ;
			uriLmen.setAttribute(nameAttr) ; }
		
		Attribute bindAttr = uriLmen.getAttribute(ConstRequestHandler.BIND) ;
		if(bindAttr==null)
		{	bindAttr = new Attribute(ConstRequestHandler.BIND, ConstRequestHandler.EXACT) ;
			uriLmen.setAttribute(bindAttr) ; }
		
		name= new JDOMAttributeField(nameAttr);
		
		bind = new JDOMRadioGroup(bindings, ConstRequestHandler.EXACT, false) ;
		bind.setAttribute(bindAttr) ;

		form = new JFormPanel() ;
		form.addField(name,"URI") ;
		form.addField(bind, "Bind") ;
		
		setDialogTitle("Request Handler") ;
		
		setLayout(new BorderLayout()) ;
		add(form, BorderLayout.NORTH) ;
	}

	@Override
	final public void initFields(List<Element> flds)
	{}

	@Override
	final public void initMethods(List<Element> mths)
	{}
}