/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.request.nouse ;

import javax.servlet.http.*;

import org.azuki.framework.annotation.*;
import org.azuki.framework.bean.Bean;

final public class ForwardServlet
{
	private String labl = null ;
	
	@MethodInfo(desc="The contract implementation of the request dispatcher aspect (RequestHandlerBean)")
	final public void service(HttpServlet svt, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{		
		if(labl==null) labl = Bean.getMetadata(this).getLabel() ;  
		svt.getServletContext().getNamedDispatcher(labl).forward(req, res) ;
	}
	
/*
	  <bean name="ForwardServlet" 
	    clas="org.azuki.bean.request.nouse.ForwardServlet"
	    desc="Forward to defined J2EE servlet"
	    vers="1.0"
		task="Standard.Servlet" 
		icon="org/azuki/bean/request/ui/icon/www.png" >

	    <pointcut name="RequestHandlerBean" labl="kernel" >
	      <method name="service" />
		  <para>
			<uri name="(undefined)" bind="exact" />
		  </para>
	    </pointcut> 

	  </bean> 
	  
	  kernel.xml
	      <instance name="ForwardServlet" labl="jsp" vers="1.0" >
	        <layer name="aop" xpos="203" ypos="69" />
	        <para />
	        <pointcut pcid="pcRequestDispatcher" name="RequestHandlerBean" labl="kernel" rlvl="10" enab="yes">
	          <method name="service" />
	          <para>
	            <uri name=".jsp" bind="endwith" />
	          </para>
	        </pointcut>
	        <layer name="injection" xpos="327" ypos="46" />
	        <layer name="ebp" xpos="300" ypos="70" />
	      </instance>
*/
} 