/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.request.server.imp;

import javax.servlet.http.*;

import org.apache.commons.codec.binary.Base64;

public class Base64Access
{	
	// Retourne le tableau [user, pass] de l'authentification BASIC
	final static public String[] getBasicAuth(HttpServletRequest req)
	{
		String auth = req.getHeader("Authorization") ;
		if(auth==null) return null ;
		
		int idx = auth.indexOf(' ') ;
		String typ = auth.substring(0, idx).trim() ;
		if(!typ.equalsIgnoreCase(HttpServletRequest.BASIC_AUTH))
			return null ;
		
		String enc = auth.substring(idx+1).trim() ;
		String dec = new String(Base64.decodeBase64(enc.getBytes())) ;
		
		idx = dec.indexOf(':') ;
		if(idx==-1) return null ;
		
		String[] ret = new String[2] ;
		ret[0] = dec.substring(0, idx) ;
		ret[1] = dec.substring(idx+1) ;
		
		return ret ;
	}	
	
	// Demande d'authentification
	final static public void askForBasicAuth(HttpServletResponse res, String realm)
	{
		StringBuilder head = new StringBuilder()
		.append(HttpServletRequest.BASIC_AUTH)
		.append(" realm=\"").append(realm).append("\"") ;
		
		res.addHeader("WWW-Authenticate", head.toString()) ;
		res.setStatus(HttpServletResponse.SC_UNAUTHORIZED) ;
	}
}