/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.request.server.imp ;

import java.net.URLDecoder;

import javax.servlet.http.*;

import org.azuki.bean.request.RequestHandlerBean;
import org.azuki.common.bean.rpc.Service;
import org.azuki.common.util.Util;
import org.azuki.framework.context.Log;

public class PDispatch
{
	// TODO ?
    public static volatile int requestCount = 0 ;

    
    // final static private SimpleDateFormat df = new SimpleDateFormat("EE, dd MMM yyyy HH:mm:ss zz", Locale.US);   

    
	final static public void process(RequestHandlerBean rha, HttpServlet srv, HttpServletRequest req, HttpServletResponse res)
    throws Exception
    {
    	req.getSession(true) ; // force JSESSIONID cookie creation
    	
    	String uri = req.getRequestURI() ;
    	uri = URLDecoder.decode(uri, "UTF-8") ;
				
		boolean debug = true ;
		
		requestCount++ ;
		
		Service service = rha.get(uri); 
		
		if(service==null)
		{
			// Default Handler
		    Log.info("["+uri+"] --> { Default Handler }") ;
//				PHandler.p(srv, req, res) ;
		    //TODO: parametrer le nom de la "default servlet" !!!
		    srv.getServletContext().getNamedDispatcher("default").forward(req, res) ;
			return ;
		}

		if(debug)
		{	
			StringBuilder sb = new StringBuilder(req.getMethod()+"[").append(uri).append("] --> {") ;
			sb.append(Util.oneString(service.name, service.labl)).append(".").append(service.meth.getName()).append("}") ;
		    Log.info(sb.toString()) ;
		}

	    if(!RequestHandlerBean.NAME.equals(service.name))
	    {
	    	/*
	    	 * HTTP/1.1 200 OK
				Server: Apache-Coyote/1.1
				ETag: W/"63330-1216824296000"
				Last-Modified: Wed, 23 Jul 2008 14:44:56 GMT
				Content-Length: 63330
				Date: Thu, 24 Jul 2008 18:18:45 GMT
	    	 */
	    	
	    	
	    	// Attention au HEAD
			if(req.getMethod().equals("HEAD"))
			{
				long now = System.currentTimeMillis() ;
				res.setDateHeader("Last-Modified", now);
				res.setDateHeader("Date", now);
				res.setHeader("ETag", "W/\""+String.valueOf(now)+"\"") ;
 				//res.setContentLength(0) ;
				res.setStatus(400) ; // OK
 				return ;
			}
	    }
		
		Object[] args = {srv, req, res} ;
		
		// Bind bean must respect RequestHandler's Contract
		service.call(args) ;
    }	    	
}