/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.scheduler.editor.imp;

import java.awt.GridLayout;
import java.awt.event.*;

import javax.swing.*;

import org.azuki.bean.scheduler.shared.ConstSched;
import org.jdom.Attribute;

@SuppressWarnings("serial")
public class TypeSelectorPanel extends JPanel implements ItemListener
{
	private boolean editable = true ;
	
	private Attribute attr ;
	
	private ButtonGroup group ;
	private JRadioButton period, time ;
	
	// CONSTRUCTEUR
	public TypeSelectorPanel()
	{
		super(new GridLayout(2, 1)) ;
		
		period = new JRadioButton("Period") ;
		time = new JRadioButton("Time") ;
		
		group = new ButtonGroup() ;
		group.add(period) ;
		group.add(time) ;

		add(period) ;
		add(time) ;
	}
	
	final public void load(Attribute attr)
	{
		this.attr = attr ;
		
		period.removeItemListener(this) ;
		time.removeItemListener(this) ;
		
		if(attr.getValue().equals(ConstSched.PERIODIC))
			period.setSelected(true) ;
		else
			time.setSelected(true) ;
		
		period.addItemListener(this) ;
		time.addItemListener(this) ;
	}

	final public boolean isEditable()
	{ return editable ;  }
	
	final public void setEditable(boolean b)
	{
		period.setEnabled(b) ;
		time.setEnabled(b) ;
		editable = b ;
	}
	
	// ItemListener
	final public void itemStateChanged(ItemEvent e)
	{
		String val = ConstSched.TIME ;
		if(e.getSource()==period) val = ConstSched.PERIODIC ;
		
		attr.setValue(val) ;
	}
}
