/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.scheduler.server.console;

import java.util.*;

import javax.servlet.http.*;

import org.azuki.bean.scheduler.SchedulerBean;
import org.azuki.common.console.HtmlFactory;
import org.azuki.common.console.html.Table;
import org.azuki.common.console.html.renderer.HourCellRenderer;
import org.azuki.common.console.http.HttpResponse;

// TODO : revoir l'affichage de la période : actuellement en heure mais peut
//        etre 1 fois par mois ou une fois par an par exemple ou que quelques jours de la semaine
public class SchedulerConsole
{
	final static public String[] jobTableHeaders = {"Job ID", "Job Name", "When", "Period", "Status"} ;
	
	final static public void service(SchedulerBean aspect, HttpServlet servlet, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{
		List<List> jobs = new ArrayList<List>() ;
		
		for (Object[] job : aspect.list())
			jobs.add(Arrays.asList(job)) ;
		
		Table jtab = HtmlFactory.sortedTable(req, jobs, jobTableHeaders) ;
		jtab.setColumnRenderer(3, new HourCellRenderer()) ;
		
		HttpResponse.print(res, jtab) ;
	}
}
