/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package org.azuki.bean.shell.editor.imp ;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;

import org.azuki.bean.shell.shared.*;
import org.azuki.common.editor.IEditorContext;
import org.azuki.common.editor.jdom.JDOMAttributeField;
import org.azuki.common.editor.page.Page;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.Element;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class ShellMethodPage extends Page 
{
	private JDOMAttributeField hlpField ;
	private JDOMAttributeField manField ;
	private JDOMAttributeField usgField ;
	
	private JFormPanel form ;
	
	/*
	 * Page
	 */
	@Override
	public void init(IEditorContext ectx, Element lmen)
	{
		Element shel = JDOMUtil.getElement(lmen, TagShell.SHELL) ;
		
		hlpField = new JDOMAttributeField(JDOMUtil.getAttribute(shel, AttrShell.HELP)) ;
		usgField = new JDOMAttributeField(JDOMUtil.getAttribute(shel, AttrShell.USAG)) ;
		manField = new JDOMAttributeField(JDOMUtil.getAttribute(shel, AttrShell.MAN)) ;
		
		form = new JFormPanel() ;
		form.addField(hlpField, "Help text") ;
		form.addField(usgField, "Usage text") ;
		form.addField(manField, "Man text") ;
		
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(form, BorderLayout.NORTH) ;
	}
}