///**
// *   Created the 2 April 2006
// *
// *   Azuki Framework
// *   Copyright 2006 the original author or authors.
// *
// *   This library is free software; you can redistribute it and/or
// *   modify it under the terms of the GNU Lesser General Public
// *   License as published by the Free Software Foundation; either
// *   version 2.1 of the License, or (at your option) any later version.
// *
// *   This library is distributed in the hope that it will be useful,
// *   but WITHOUT ANY WARRANTY; without even the implied warranty of
// *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// *   Lesser General Public License for more details.
// *
// *   You should have received a copy of the GNU Lesser General Public
// *   License along with this library; if not, write to the Free Software
// *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
// *   
// *   Contact : support@azuki-framework.org
// *
// *   @author Mathieu Jucker
// */
//
//package org.azuki.bean.shell.server;
//
//import java.lang.reflect.*;
//import java.util.*;
//
//import org.azuki.bean.shell.shared.*;
//import org.azuki.common.consts.Tag;
//import org.azuki.framework.aop.IPointcut;
//import org.azuki.framework.bean.IMetadata;
//import org.azuki.framework.injection.IMethodProxy;
//import org.azuki.framework.object.Locator;
//import org.jdom.Element;
//
//final public class ShellAdvice
//{
//	final static private String UNDEFINED = "undefined" ;
//	
//	final private IPointcut pc ;
//	final public  IPointcut getPointcut() { return pc ; }
//	
//	final private Map<String,String> mman = new HashMap<String,String>() ;
//	final private Map<String,String> mhlp = new HashMap<String,String>() ;
//	final private Map<String,String> musg = new HashMap<String,String>() ;
//	
//	public ShellAdvice(IPointcut pc)
//	throws Exception
//	{
//		this.pc = pc ;
//		
//		for(Method meth : pc.getSelectedMethods())
//		{
//			Element lmen = pc.getElement(meth) ;
//			if(lmen==null) continue ;
//			
//			lmen = lmen.getChild(Tag.PARA) ;
//			if(lmen==null) continue ;
//			
//			lmen = lmen.getChild(TagShell.SHELL) ;
//			if(lmen==null) continue ;
//			
//			String name = meth.getName() ;
//			
//			mman.put(name, lmen.getAttributeValue(AttrShell.MAN,  UNDEFINED)) ;
//			mhlp.put(name, lmen.getAttributeValue(AttrShell.HELP, UNDEFINED)) ;
//			musg.put(name, lmen.getAttributeValue(AttrShell.USAG, UNDEFINED)) ;
//		}
//	}
//	
//	
//	final public String getMan(String meth)
//	{
//		String str = mman.get(meth) ;
//		return str==null ? UNDEFINED : str ;
//	}
//	
//	final public String getHelp(String meth)
//	{
//		String str = mhlp.get(meth) ;
//		return str==null ? UNDEFINED : str ;
//	}
//	
//	final public String getUsage(String meth)
//	{
//		String str = musg.get(meth) ;
//		return str==null ? UNDEFINED : str ;
//	}
//	
//	final public String call(String meth, String... args)
//	throws Exception
//	{
//		IMetadata tmeta = pc.getTargetMetadata() ;
//		IMethodProxy mp = (IMethodProxy)Locator.create(Locator.OBJECT_METHOD_PROXY, tmeta.getName(), tmeta.getLabel(), meth) ;
//	
//		Method m = findMethod(pc, meth) ;
//		
//		Class[] pts = m.getParameterTypes() ;
//		boolean str = pts.length==1 && pts[0]==String.class ; 	// pour 1 argument de type String  
//		boolean arr = pts.length==1 && pts[0].isArray() ;		// pour 1 argument de type Object[]/Object...
//			
//		Object ret = null ;
//		if(str) 		ret = mp.call(parseArgs(args)) ;
//		else if(arr)	ret = mp.call(new Object[]{args}) ;
//		else			ret = mp.call((Object[])args) ;
//		
//		return m.getReturnType()==void.class && ret==null ? "" : String.valueOf(ret) ;
//	}
//	
//	final static private Method findMethod(IPointcut pc, String name)
//	{
//		for(Method m : pc.getSelectedMethods())
//		{
//			if(m.getName().equals(name))
//				return m ;
//		}
//		return null ;
//	}
//	
//	final static private String parseArgs(String... args)
//	{
//		StringBuilder bdr = new StringBuilder() ;
//		
//		boolean first = true ;
//		
//		for(String arg : args)
//		{
//			if(!first)  bdr.append(' ') ;
//			else		first = false ;
//			
//			boolean quot = arg.indexOf(' ')!=-1 ;
//			
//			if(quot) bdr.append('"') ;
//			bdr.append(arg) ;
//			if(quot) bdr.append('"') ;
//		}
//		
//		return bdr.toString() ;
//	}
//}
