/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin
 */

package org.azuki.bean.tomcat.server.console ;

import java.util.*;

import javax.servlet.http.*;

import org.azuki.bean.tomcat.TomcatConnectorBean;
import org.azuki.common.console.HtmlFactory;
import org.azuki.common.console.html.*;
import org.azuki.common.console.http.HttpResponse;
import org.azuki.common.util.Util;
import org.azuki.framework.bean.*;


// Console view for Tomcat Bean

final public class TomcatConnectorConsole
{
	final static public void service(TomcatConnectorBean tcb, HttpServlet srv, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{
		IMetadata meta = Bean.getMetadata(tcb) ;
		
		Map<String,Object> map = new HashMap<String,Object>() ;
		map.put("Port", Integer.valueOf(tcb.getPort())) ;
		map.put("Scheme", tcb.getScheme()) ;
		map.put("Keystore file", tcb.getKeystoreFile()) ;
		//map.put("Keystore password", tcb.getKeystorePass()) ;
		map.put("Max. threads", Integer.valueOf(tcb.getMaxThreads())) ;
		map.put("Min. spare threads", Integer.valueOf(tcb.getMinSpareThreads())) ;
		map.put("Max. spare threads", Integer.valueOf(tcb.getMaxSpareThreads())) ;
		map.put("Accept count", Integer.valueOf(tcb.getAcceptCount())) ;
		map.put("Thread priority", Integer.valueOf(tcb.getMaxThreads())) ;
		
		Table tabl = HtmlFactory.propertyList("Properties", map) ;
		
		HtmlBuilder bdr = new HtmlBuilder() ;
		bdr.print("<h2>").print(Util.oneString(meta.getName(), meta.getLabel())).print("</h2>") ;
		bdr.println("<br/>") ;
		bdr.print(tabl) ;
		
		HttpResponse.print(res, bdr) ;
	}
}