/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin
 */

package org.azuki.bean.tomcat.server.imp ;

import java.io.File;
import java.util.logging.*;

import org.azuki.framework.context.Log;

final public class PTomcatLog
{	
	// Tomcat logging setup
	final static public void configure(String dir, String lvl)
	{
		Logger logger = Logger.getLogger("org.apache") ;
		
		File f = new File(dir) ; 
		if(!f.exists()) f.mkdirs() ;
		
		Handler hdlr = null ;
		try
		{ 
			hdlr = new TomcatLogHandler(dir) ;
			logger.setUseParentHandlers(false) ;
			logger.addHandler(hdlr) ;
		}
		catch(Exception ex)
		{
			Log.severe(Log.getStack(ex)) ;
		}
		
		logger.setLevel(Level.parse(lvl)) ;
		
		Log.info("Tomcat server log level ("+logger.getLevel()+")") ;
	}
}