package org.azuki.bean.transaction.editor ;

import java.awt.BorderLayout;
import java.util.List;

import javax.swing.BorderFactory;

import org.azuki.bean.transaction.TransactionBean.DTAction;
import org.azuki.bean.transaction.shared.ConstTransaction;
import org.azuki.common.editor.jdom.JDOMComboField;
import org.azuki.common.editor.pointcut.AbstractPointcutEditor;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

@SuppressWarnings("serial")
public class TransactionPointcutEditor extends AbstractPointcutEditor
{
	JDOMComboField bforField ;
	JDOMComboField aftrField ;
	JDOMComboField erroField ;
	
	JFormPanel form ;
	
	@Override
	final public void initParameters(Element para)
	{
		Element tranLmen = JDOMUtil.getElement(para, ConstTransaction.TRAN) ;
		Attribute bforAttr = JDOMUtil.getAttribute(tranLmen, ConstTransaction.TRAN_BFOR) ; 
		Attribute aftrAttr = JDOMUtil.getAttribute(tranLmen, ConstTransaction.TRAN_AFTR) ;
		Attribute erroAttr = JDOMUtil.getAttribute(tranLmen, ConstTransaction.TRAN_ERRO) ;
		
		bforField = new JDOMComboField((Object[])DTAction.values()) ;
		bforField.setAttribute(bforAttr) ;
		
		aftrField = new JDOMComboField((Object[])DTAction.values()) ;
		aftrField.setAttribute(aftrAttr) ;
		
		erroField = new JDOMComboField((Object[])DTAction.values()) ;
		erroField.setAttribute(erroAttr) ;
		
		form = new JFormPanel() ;
		form.addField(bforField, "Before") ;
		form.addField(aftrField, "After") ;
		form.addField(erroField, "On error") ;
		
		setDialogTitle("Data transaction management") ;
		
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(form, BorderLayout.NORTH) ;	
	}
	
	@Override
	final public void initFields(List<Element> flds)
	{}

	@Override
	final public void initMethods(List<Element> mths)
	{}
}