/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.console.renderer;

import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class TimeRenderer
{
	final static private SimpleDateFormat TIMF = new SimpleDateFormat("HH:mm:ss") ;
	final static private SimpleDateFormat DAYF = new SimpleDateFormat("MMM-dd HH:mm") ;
	
	final static public String get(Number time)
	{
		if(time==null)
			return String.valueOf(time) ;
				
		Calendar cur = Calendar.getInstance() ;
		Calendar cal = Calendar.getInstance() ;
		cal.setTimeInMillis(time.longValue()) ;
		
		if(cal.get(Calendar.DAY_OF_YEAR)!=cur.get(Calendar.DAY_OF_YEAR))
			return DAYF.format(time) ;
		
		return TIMF.format(time) ;
	}
}