package org.azuki.common.dag;


public class Link<T>
{
	final public String key ;
	final public Node<T> parent ;
	final public Node<T> child  ;
	
	public Link(Node<T> parent, Node<T> child)
	{
		this.parent = parent ;
		this.child  = child  ;
		key = new StringBuilder(child.getKey()).append("<").append(parent.getKey()).toString() ;
	}
	
	@Override
	final public String toString()	{ return key ;	}

	@Override
	final public int hashCode() { return key.hashCode(); }

	@Override
	final public boolean equals(Object link)
	{
		if (this == link) return true ;
		if (link == null) return false ;
		if (Link.class != link.getClass()) return false;
		if(key.equals(((Link)link).key))   return true ;
		return false ;
	}
}