/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.editor ;

import java.net.URL;
import java.util.*;

import org.azuki.common.reflect.BeanInfo;
import org.jdom.Element;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public interface IEditorContext
{
	public BeanInfo getInfo() ;
	public String 	getLabel() ;
	
	public Element getParameters() ; 				// a clone of current PARA Element
	public Element getDefaultParameters() ; 		// a clone of beans.xml PARA Element
	
	public URL 		getResource(String name) ;		// an URL or the specified resource ("one/two/three.txt")
	public byte[] 	getResourceBytes(String name) ;	// the specified resource content as byte[] ("one/two/three.txt")
	
	public BeanInfo getBeanInfo(String name) ;		// the bean with the specified name
	public Collection<BeanInfo> getBeanInfos() ;	// all available beans infos
	
	public Collection<String> getDeclaredInstances(String beanName) ; // List<bean.labl> of the specified bean name
	public Collection<String> getDeclaredTopics() ; 				  // List<topic.name> of declared topics
}