/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.editor ;

import java.lang.reflect.*;
import java.util.Collection;

import org.azuki.common.reflect.BeanInfo;
import org.azuki.framework.aop.IContract.Selection;
import org.jdom.Element;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public interface IPointcutEditorContext extends IEditorContext
{
	public BeanInfo getTargetInfo() ;			// info of the bean which pointcut applied
	public String 	getTargetLabel() ;			// label of the bean which pointcut applied
	
	public Field[] getFields() ;				// public bean fields
	public Selection getFieldSelection() ;		// field selection configuration
	
	public Method[] getMethods() ;				// public bean methods
	public Selection getMethodSelection() ;		// method selection configuration
	
	public Collection<Element> getSelectedFields() ;	// a clone of each current selected fields
	public Collection<Element> getSelectedMethods() ;	// a clone of each current selected methods
}