/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.editor.basic;

import java.awt.BorderLayout;

import org.azuki.common.editor.jdom.JDOMElementTableBinding;
import org.azuki.common.editor.page.TablePage;
import org.jdom.Element;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class TableEditor extends AbstractEditor 
{
	// Make sure to setup your "table bindings" before the init() method call !
	private JDOMElementTableBinding tableBinding = JDOMElementTableBinding.getDefault() ; 
	
	final public JDOMElementTableBinding getTableBinding()
	{
		return this.tableBinding ;
	}
	
	final public void setTableBinding(JDOMElementTableBinding tableBinding)
	{
		this.tableBinding = tableBinding ;
	}
	
	private TablePage tablePage ;
	
	/*
	 * AbstractEditor
	 */
	@Override
	public void initParameters(Element para)
	{
		if(tableBinding==null)
			throw new IllegalArgumentException("invalid table binding: "+tableBinding) ;
		
		tablePage = new TablePage() ;
		tablePage.setTableBinding(tableBinding) ;
		tablePage.init(getContext(), para) ;
		
		setDialogTitle("Table Editor") ;
		
		setLayout(new BorderLayout()) ;
		add(tablePage, BorderLayout.CENTER) ;
	}
}