/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.editor.jdom;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JCheckBox;

import org.jdom.Attribute;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class JDOMCheckBox extends JCheckBox implements ItemListener
{
	private String checkVal;
	private String uncheckVal;
	private boolean selected;
	
	protected Attribute initAttr ;
	//private boolean hasChanged=false;
	
	public JDOMCheckBox()
	{
		this(Boolean.TRUE.toString(), Boolean.FALSE.toString()) ;
	}
	
	public JDOMCheckBox(String checkVal, String uncheckVal)
	{
		this(checkVal, uncheckVal, false) ;
	}
	
	public JDOMCheckBox(String checkVal, String uncheckVal, boolean def)
	{
		this.checkVal = checkVal ;
		this.uncheckVal = uncheckVal ;
		this.selected  = def;
		this.addItemListener(this);
	}

	public void itemStateChanged(ItemEvent e)
	{
		if (isSelected())
			initAttr.setValue(checkVal);
		else
			initAttr.setValue(uncheckVal);
		//hasChanged=true;
	}

	public void setAttribute(Attribute attr)
	{
		initAttr = attr;
		String val = attr.getValue();
		if (val!=null && !val.isEmpty())
		{
			if (val.equals(checkVal)) 
				setSelected(true);
			else
				setSelected(false);
		}
		else
			setSelected(this.selected);
	}

	public Attribute getAttribute()
	{
		return initAttr;
	}
	
//	public boolean hasChanged()
//	{
//		return hasChanged();
//	}
}
