/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.reflect ;

import java.lang.reflect.*;

import org.azuki.framework.aop.IContract;

/**
 * @author Robert Bakic (robert.bakic@gmail.com)
 */

public class Contract implements IContract
{
	static private Contract inst = null ;
	final static public Contract getDefault()
	{
		if(inst==null) inst = new Contract() ;
		return inst ;
	}
	
	final static public Field[] getFieldCandidates(IContract ctrt, Class beanClass)
	{
		if(ctrt==null) return new Field[0] ;
		
		Field[] flds = ctrt.getFieldCandidates(beanClass) ;
		if(flds==IContract.ALL_FIELDS) flds = beanClass.getFields() ;
		
		return flds ;
	}
	
	final static public Method[] getMethodCandidates(IContract ctrt, Class beanClass)
	{
		if(ctrt==null) return new Method[0] ;
		
		Method[] mths = ctrt.getMethodCandidates(beanClass) ;
		if(mths==IContract.ALL_METHODS) mths = beanClass.getMethods() ;
		
		return mths ;
	}
	
	//
	// IContract
	//
	final public void checkBindable(Class beanClass)
	throws Exception
	{}
	
	final public Selection getFieldSelection()
	{
		return Selection.UNCHECKED ;
	}
	
	final public Field[] getFieldCandidates(Class beanClass)
	{
		return beanClass.getFields() ;
	}
	
	final public Selection getMethodSelection()
	{
		return Selection.UNCHECKED ;
	}
	
	final public Method[] getMethodCandidates(Class beanClass)
	{
		return beanClass.getMethods() ;
	}
} 