/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.widget ;

import java.awt.*;
import java.awt.geom.Point2D;

import javax.swing.JPanel;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
final public class JGradientPanel extends JPanel 
{
	private Color c1 ;
	private Color c2 ;
	
	private GradientPaint gradient ;
	
	public JGradientPanel(Color c1, Color c2)
	{
		this.c1 = c1 ;
		this.c2 = c2 ;
	}
	
	@Override
	protected void paintComponent(Graphics g)
	{
		int w = getWidth() ;
		int h = getHeight() ;
		
		if(gradient==null)
		{
			gradient = new GradientPaint(0, 0, c1, w, h, c2, false) ;
		}
		else
		{
			Point2D pt = gradient.getPoint2() ;
			if(pt.getX()!=w || pt.getY()!=h)
				gradient = new GradientPaint(0, 0, c1, w, h, c2, false) ;
		}

		Graphics2D g2 = (Graphics2D) g ;
		g2.setPaint(gradient) ;
		g2.fillRect(0, 0, w, h) ;
	}
}