/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.widget ;

import java.awt.*;

import javax.swing.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class JHTMLPane extends JEditorPane
{
	final static public String htmlContentType = "text/html" ;
	
	protected JDialogPanel dialog ;
	
	public JHTMLPane()
	{
		this("") ;
		
		//setEditorKit(new XHTMLEditorKit()) ;
	}
	
	public JHTMLPane(String htmlText)
	{
		super(htmlContentType, htmlText) ;
		
		setCaretPosition(0) ;
		setEditable(false) ;
	}
	
	final public void showDialog(Component parent, String title)
	{
		dialog = new JDialogPanel(new BorderLayout()) ;
		dialog.add(new JScrollPane(this)) ;
		
		dialog.showDialog(parent, title, new String[]{}, null) ;
	}
}