/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.framework.aop;

import java.lang.reflect.*;

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

/*
 * XML rules:
 *   - xml attribute EMPTY or NULL   -> use default contract
 *   - clas not found / not instance -> NULL
 *   - otherwise                     -> the defined contract instance 
 */

public interface IContract
{
	public enum Selection { NONE, ONLY_ONE, AT_LEAST_ONE, UNCHECKED } 
	
	static public Method[] ALL_METHODS = null ;	
	static public Field[] ALL_FIELDS   = null ;

	public void checkBindable(Class beanclass)
	throws Exception ;
	
	public Selection getFieldSelection() ;

	// if returns null then the weaver select all the public method
	public Field[] getFieldCandidates(Class beanclass) ;

	public Selection getMethodSelection() ;
	
	// if returns null then the weaver select all the public method
	public Method[] getMethodCandidates(Class beanclass) ;
}