/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.framework.bean;

import java.util.List;

import org.azuki.framework.aop.*;
import org.azuki.framework.command.IQueue;
import org.azuki.framework.injection.IController;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

public interface IMetadata 
{
	public IQueue getQueue() ;
	public void   setQueue(IQueue queue) ;
	
	public String getUniverse() ; 
	public String getSchema() ; 
	
	public Integer getID();
    public String  getName();
    public String  getLabel() ;
	
	public Object  getBean() ;
	public Class   getBeanClass() ;
	
	public boolean isAspect() ; // implements IAspect
	public IContract getContract() ;
	
	public String getDescription() ;
    public String getVersion() ;
//	public int    getRunLevel();
	
	public String getIcon() ;
	public String getGroup() ;
	
	// PointCuts
	public IPointcut       getPointcut(Integer  pcid) ; // Point Cut ID
	public List<IPointcut> getPointcuts() ;
	public List<IPointcut> getPointcuts(String  name) ; // ! With differents label !
	public List<IPointcut> getPointcuts(Integer aspid);	// aspect ID

	public IController[] getControllers() ; // retrieves Code advice implementing IController
}