/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.kernel;

import java.io.File;
import java.net.*;
import java.util.*;

import org.azuki.common.util.Util;
import org.azuki.framework.Framework;

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class Server
{
	/**
	 * The working directory IS NOT THE MODULE DIRECTORY !!
	 * => assuming we are in the framework home (ie. "$azuki_root")
	 */
	final static public void main(String[] args)
	{
		try
		{
			String path = "module" ;
			if(args.length>=1) path = args[0] ;
			
			System.out.println("Module path ("+path+")") ;
			System.out.println() ;
		
			List<URL> libs = new ArrayList<URL>() ;
			
			// listing module libraries
			libs.addAll(Util.listURLs(new File(path), true)) ;
			
			// initializing classloader
			ClassLoader cl = Thread.currentThread().getContextClassLoader() ;
			if(!libs.isEmpty())
			{	cl = new URLClassLoader(libs.toArray(new URL[libs.size()]), cl) ;
				Thread.currentThread().setContextClassLoader(cl) ; }
			
			// Initialisation du framework
			Framework.init(cl) ;
		}
		catch(Exception e)
		{
			e.printStackTrace() ;
		}
	}
}