/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.kernel.framework;

import java.util.*;

import org.azuki.framework.aop.IPointcut;
import org.azuki.framework.bean.*;
import org.azuki.kernel.metadata.*;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class BeanImpl implements Bean.Impl
{
	final static public String BeanNotFound = "Bean not found : " ;
	
	final public IMetadata getMetadata(Object bean)
	throws Exception
	{
		IMetadata meta = TO.getWrapper(bean) ;
		if(meta==null) throw new Exception(BeanNotFound+bean) ;
		return meta ;
	}

	final public IMetadata getMetadata(Integer bid)
	throws Exception
	{
		BW bw = TO.lookup(bid) ;
		if(bw==null) throw new Exception(BeanNotFound+bid) ;
		return bw  ;
	}	

	final public boolean isBean(Object obj)
	{
		if(TO.getWrapper(obj)!=null) return true ;
		return false ;
	}

	final public Collection<IMetadata> search(String name, String labl)
	{
		return  TO.search(name, labl) ;		
	}

	final public IMetadata searchFirst(String name, String labl)
	{
		return  TO.searchFirst(name, labl) ;		
	}

	final public Collection<IPointcut> getPointcuts(Integer aspid)
	{
		Collection<BW> cos = TO.getAll() ;

		ArrayList<IPointcut> list = new ArrayList<IPointcut>() ;
		
		for(BW bow : cos)
		{			
			for(IPointcut ipc : bow.getPointcuts(aspid))
				list.add(ipc) ;
				
		}
		return list ;
	}

	@SuppressWarnings("unchecked")
	final public Collection<IPointcut> getPointcuts(String name)
	{
		Collection cos = TO.getAll() ;

		ArrayList<IPointcut> list = new ArrayList<IPointcut>() ;
		
		for(IMetadata bow : (Collection<IMetadata>)cos)
		{			
			for(IPointcut ipc : bow.getPointcuts(name))
				list.add(ipc) ;
				
		}
		return list ;
	}	
}