/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.kernel.framework;

import java.io.InputStream;
import java.net.URL;
import java.util.Enumeration;

import org.azuki.common.consts.Const;
import org.azuki.common.framework.BeanRepository;
import org.azuki.framework.Framework;
import org.azuki.framework.bean.Bean;
import org.azuki.framework.context.*;
import org.azuki.framework.object.Locator;
import org.azuki.kernel.weaving.*;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class FwrkImpl implements Framework.Impl
{
	final static private Bean.Impl    beaimpl = new BeanImpl() ;
	final static private Locator.Impl locimpl = new LocatorImpl() ;
	
	final public Bean.Impl      getBeanImpl()    { return beaimpl; }
	final public Locator.Impl   getLocatorImpl() { return locimpl; }
	
	static private boolean startInit = false ;
	static public  boolean endInit   = false ;
	
	final public void init(ClassLoader ccl)
	throws Exception
	{
		sinit(ccl) ;
	}
	
	final static public void sinit(ClassLoader ccl)
	throws Exception
	{
		if(startInit) return ; // Already initialized
		startInit = true ;

		try
		{
			BeanRepository.init(ccl, Log.getLogger()) ; 

		    Enumeration<URL> enu = ccl.getResources(Const.MODULE_FILE) ;
			while(enu.hasMoreElements())
			{
			    URL url = enu.nextElement() ;
			    
			    Log.info("") ;
			    Log.info("************************************************************************") ;
			    Log.info(" STARTING WEAVING FOUND IN LOCATION = "+url) ;
			    Log.info("************************************************************************") ;
			    Log.info("\n") ;
			
			    initWeaving(url) ;				
			}
		}
		finally
		{
			endInit = true ;
			ThreadContext.reset();
		}
	}
		
	final static private void initWeaving(URL url)
	{
		InputStream is = null ;
		
		try
		{
			is = url.openStream() ; // lecture
			P1Universe.init(is) ;
		}
		catch(Exception e)
		{
			e.printStackTrace() ;
		}
		finally
		{
			try
			{
				if(is!=null) is.close() ;
			}
			catch(Exception e) {}
		}
	}		
}