/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.kernel.weaving ;

import java.util.List;

import org.azuki.common.consts.*;
import org.azuki.common.util.Util;
import org.azuki.framework.context.Log;
import org.azuki.kernel.metadata.*;
import org.jdom.Element;

final public class PPointCut
{
	@SuppressWarnings("unchecked")
	final static public void definePointcuts(BW targetmeta, Element lmen)
	{
		List<Element> list = lmen.getChildren(Tag.POINTCUT) ;
		
		int pcid = 0 ;
		
		for(Element lm : list)
		{
			boolean bena = Util.isOK(lm.getAttributeValue(Attr.ENAB, Const.YES)) ;			
			if(!bena) {	continue ; }

			
			String aspname = lm.getAttributeValue(Attr.NAME) ;
			String asplabl = lm.getAttributeValue(Attr.LABL, "") ; // no labl=""
			
			StringBuilder sb = new StringBuilder("\t(*) Pointcut [").append(pcid).append(',')
			.append(Util.oneString(aspname, asplabl)).append("]") ;

			Log.info(sb.toString()) ;
			
			targetmeta.addPointcut(new PC(pcid++, aspname, asplabl, targetmeta, lm) ) ;
		}		
	}
}